<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '../../common/meta';
import { SolutionsHero } from '../../components/solutions/index.vue';
import SupportCopyMarkdownServices from '../../components/support/copy-markdown-services.vue';
import ServicesForm from '../../components/services/form.vue';
import { CONTENT_TYPES } from '../../common/content-types';
import { getClient } from '../../plugins/contentful';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { LivePreviewMixin } from '~/mixins';
import { ServicesPgHelper } from '~/services/services.service';
import { convertToCaseSensitiveLocale } from '~/common/util';

export default Vue.extend({
  components: {
    ServicesForm,
    SupportCopyMarkdownServices,
    SolutionsHero,
  },
  nuxtI18n: {
    locales: ['en-us', 'de-de', 'fr-fr', 'ja-jp'],
  },
  mixins: [LivePreviewMixin],
  async asyncData({ i18n }) {
    const locale = convertToCaseSensitiveLocale(i18n.locale);

    try {
      const content = await getClient()
        .getEntries({
          content_type: CONTENT_TYPES.PAGE,
          'fields.slug': 'professional-services',
          include: 10,
          locale,
        })
        .then((query: any) => {
          const entryFields = query.items[0]?.fields;
          return ServicesPgHelper(entryFields);
        });

      return { content };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).content,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.content,
        callback: (updatedData) =>
          (this.content = ServicesPgHelper(updatedData)),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <section class="services">
    <SolutionsHero :data="content.hero" />
    <SlpContainer>
      <SlpSideNavigation :data="content.side_menu" class="services__navigation">
        <template #header>
          <div class="services__nav-buttons">
            <SlpButton
              v-for="(button, buttonIndex) in content.side_menu.hyperlinks.data"
              :key="buttonIndex"
              :variant="button.variant"
              :href="button.href"
              :data-ga-name="button.data_ga_name"
              :data-ga-location="button.data_ga_location"
              >{{ button.text }}
            </SlpButton>
          </div>
        </template>
        <SlpRow>
          <SlpColumn :cols="11">
            <SupportCopyMarkdownServices
              v-for="(section, i) in content.service_cards"
              :key="i"
              :data="section"
            />
          </SlpColumn>
        </SlpRow>
      </SlpSideNavigation>
      <SlpSideButton
        data-ga-name="to-top"
        data-ga-location="body"
        class="services__to-top"
      />
    </SlpContainer>
    <SlpContainer variant="gradient" class="slp-pb-96">
      <ServicesForm :data="content.form"></ServicesForm>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.services {
  &__nav-buttons {
    width: 100%;
    margin-bottom: $spacing-24;

    .slp-btn {
      width: 100%;
      justify-content: center;
      margin-bottom: $spacing-8;
    }

    .slp-btn-secondary {
      padding: 11px 0;
    }
  }

  &__to-top {
    display: none;

    @media (min-width: $breakpoint-md) {
      display: inherit;
    }
  }

  &__navigation {
    &:deep(.dropdown) {
      margin: $spacing-32 0;
    }
  }
}
</style>
